#include "sheep.h"

char level_filename[256];

LEVEL *load_level(char *filename) {
 LEVEL *level;
 FILE *f=fopen(filename,"rt");
 if (f==0) return 0;
 level=malloc(sizeof(LEVEL));
 fscanf(f,"%d%d%d",&level->w,&level->h,&level->n_bubbles);
 if (level->n_bubbles>MAX_BUBBLES) level->n_bubbles=MAX_BUBBLES;
 level->tile=malloc(sizeof(TILE *)*level->h);
 {
  int y;
  for (y=0;y<level->h;y++) {
   level->tile[y]=malloc(sizeof(TILE)*level->w);
   fscanf(f,"%s",tempstr);
   {
    int x;
    for (x=0;x<level->w;x++) level->tile[y][x]=tempstr[x]-'0';
   }
  }
 }
 fclose(f);
 return level;
}

void destroy_level(LEVEL *level) {
 {
  POP *pop=level->pop;
  while (pop) {
   POP *next=pop->next;
   free(pop);
   pop=next;
  }
 }
 {
  int y;
  for (y=0;y<level->h;y++) free(level->tile[y]);
 }
 free(level->tile);
 free(level);
}
